## ada-reference-manual 2012.3

=== build/Makefile ===
# Compilation of the Scribe formatter written for the Ada Reference
# Manual, translating .ms[ms] files into various formats. Also build
# tar.gz for the web page.

# Copyright (c) 2010, 2013 Stephen Leake <stephen_leake@stephe-leake.org>
# Copyright (c) 2013       Nicolas Boulenguez <nicolas@debian.org>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# Specific targets generate every $document$year.$format combination.
# Ex: make arm2012.pdf
AVAILABLE_DOCUMENTS := aarm arm
AVAILABLE_YEARS     := 2005 2012
AVAILABLE_FORMATS   := html info texinfo txt pdf

# 'all' builds all versions except pdf; to build a subset, override these on the command line.
DOCUMENTS := $(AVAILABLE_DOCUMENTS)
YEARS     := $(AVAILABLE_YEARS)
FORMATS   := $(filter-out pdf texinfo, $(AVAILABLE_FORMATS))
# Texinfo is an intermediate, and is built as necessary.
# Pdf requires installation of many huge formatting tools; we assume they are not installed.

# see ../README.txt for list of things to change when Scribe or Ada source changes.
#
# Cygwin texi2dvi (GNU Texinfo 4.13) 1.135 fails silently!

# Debian standard build flags for Ada projects
BUILDER_OPTIONS := -k
ADAFLAGS        :=
LDFLAGS         :=
# arm_info.gpr sets its own flags, then appends these variables so
# that they take precedence.  The intent is that you may configure the
# build with a simple variable override.

.PHONY: all clean publish

all: $(foreach d,$(DOCUMENTS),\
     $(foreach y,$(YEARS),\
     $(foreach f,$(FORMATS),\
       $(d)$(y).$(f))))

# We have been unable to get rid of all the section ref violations, so we
# specify --no-validate. Delete that to see the errors.
TEXI_INFO_OPTS := --no-split --no-number-sections --no-validate
TEXI_PDF_OPTS := --quiet

SOURCE_DIR_2005 := ../source_2005
SOURCE_DIR_2012 := ../source_2012

# See progs/command.txt.
CHANGES      := New-Only
# See arm_form.exe help for possible values
VERSION_2005 := 2
VERSION_2012 := 4

# Mapping from document acronyms to Randy's file names
MASTER_arm  := rm.msm
MASTER_aarm := aarm.msm

# Rough dependency, but Scribe files should not change often.
SOURCES_2005 := $(wildcard $(SOURCE_DIR_2005)/*.ms[ms])
SOURCES_2012 := $(wildcard $(SOURCE_DIR_2012)/*.ms[ms])
define doc_year_build

  # Non-unique intermediate paths would create a race condition, so we
  # store the temporary result into the versioned source directory.
  $(d)$(y).texinfo: arm_form.exe $(SOURCES_$(y))
	cd $(SOURCE_DIR_$(y)); \
        $(CURDIR)/$$< $(MASTER_$(d)) info $(CHANGES) $(VERSION_$(y)) $(VERSION_$(y)) ./; \
        mv `sed -ne '/^@FilePrefix{\(.*\)}/{s//\L\1/p;q}' $(MASTER_$(d))`.texinfo $(CURDIR)/$$@
  clean::
	rm -f $(d)$(y).texinfo

  $(d)$(y).html: arm_form.exe $(SOURCES_$(y))
	rm -f -r $$@
	mkdir --parents $$@
	cd $(SOURCE_DIR_$(y)); \
        $(CURDIR)/$$< $(MASTER_$(d)) HTML $(CHANGES) $(VERSION_$(y)) $(VERSION_$(y)) $(CURDIR)/$$@/
  clean::
	rm -f -r $(d)$(y).html

  $(d)$(y).txt: arm_form.exe $(SOURCES_$(y))
	rm -f -r $$@
	mkdir --parents $$@
	cd $(SOURCE_DIR_$(y)); \
        $(CURDIR)/$$< $(MASTER_$(d)) Text $(CHANGES) $(VERSION_$(y)) $(VERSION_$(y)) $(CURDIR)/$$@/
  clean::
	rm -f -r $(d)$(y).txt

# texi2any is from texinfo 5
  $(d)$(y).info: $(d)$(y).texinfo
	texi2any --info $(TEXI_INFO_OPTS) $$< -o $$@
  clean::
	rm -f $(d)$(y).info

  $(d)$(y).pdf: $(d)$(y).texinfo
	texi2any --pdf $(TEXI_PDF_OPTS) $$< -o $$@
  clean::
	rm -f $(d)$(y).log $(d)$(y).pdf $(d)$(y).toc

endef
$(foreach d,$(AVAILABLE_DOCUMENTS),\
$(foreach y,$(AVAILABLE_YEARS),\
$(eval $(doc_year_build))))

arm_form.exe : force
	gnatmake -p $(BUILDER_OPTIONS) -P arm_info.gpr $(foreach var,ADAFLAGS LDFLAGS,"-X$(var)=$($(var))")
clean::
	rm -f arm_form.exe
	rm -f -r objects

trace :
	addr2line -e arm_form.exe 0x51009e 0x5298ca 0x401fc2 0x405169 0x4013db 0x76cc7c02 0x76f3ab8d 0x76f3ab58

# year is latest standard; bump trailing digit for any change.
ZIP_VERSION := $(lastword $(AVAILABLE_YEARS)).3

INFO_ARCHIVE := arm_info-$(ZIP_VERSION).tar.gz
SOURCE_ARCHIVE  := arm_info-$(ZIP_VERSION)-src.tar.gz
publish: $(INFO_ARCHIVE) $(SOURCE_ARCHIVE)

# --no-name eliminates time stamps, which helps make the tarball reproducible
# --best gives higher compression than the default; we can afford the time here.
GZIP := --no-name --best

$(INFO_ARCHIVE): $(foreach d,$(DOCUMENTS),\
                 $(foreach y,$(YEARS),\
                 $(d)$(y).info))
	tar cf - $^ | gzip $(GZIP) -c > $@
clean::
	rm -f $(INFO_ARCHIVE)

ZIP_EXCLUDES := *~ *.dvi *.gz *.info *.log *.pdf *.ps *.texinfo *.toc \
  *.stamp *.zip arm_form.exe _MTN .mtn-ignore .dvc-exclude aarm2005.html \
  aarm2005.txt aarm2012.html aarm2012.txt arm2005.html arm2005.txt arm2012.html \
  arm2012.txt objects
$(SOURCE_ARCHIVE):
	tar cf - -C ../.. $(foreach e,$(ZIP_EXCLUDES),--exclude="$(e)") org.adaic.arm_form | gzip $(GZIP) -c > $@
clean::
	rm -f $(SOURCE_ARCHIVE)

update_upstream : source_ada.clean         source_ada.stamp
update_upstream : source_scribe_2005.clean source_scribe_2005.stamp
update_upstream : source_scribe_2012.clean source_scribe_2012.stamp

# download.py does not convert to unix line endings here to minimize
# the diff with upstream; the Ada compiler can handle DOS line endings
# on Unix. download.py does convert file names to lower case here, for
# consistency.
source_ada.stamp :
	rm -rf ../../org.adaic.arm_form.upstream/progs
	cd ../../org.adaic.arm_form.upstream; python3 ../org.adaic.arm_form/build/download.py progs
	touch source_ada.stamp

source_ada.clean :
	rm -f source_ada.stamp

# This retrieves the CVS tag for the year given on the command line
# commit to mtn: (dvc-status "../../org.adaic.arm_form.upstream")
#
# download.py converts to unix line endings here, because the scribe
# processor insists on uniform formatting; this works for both Windows
# and Debian. download.py also converts all file names to lowercase,
# and arm_form does as well; upstream only runs on Windows, which
# ignores case in filenames, so the file names in the sources are not
# consistently cased.
source_scribe_%.stamp :
	rm -rf ../../org.adaic.arm_form.upstream/source_$*
	cd ../../org.adaic.arm_form.upstream; python3 ../org.adaic.arm_form/build/download.py $*
	mv ../../org.adaic.arm_form.upstream/source ../../org.adaic.arm_form.upstream/source_$*
	touch source_scribe_$*.stamp

source_scribe_%.clean :
	rm -f source_scribe_$*.stamp

# These sources do not match teh correpsonding CVS tag, although they are close.
ARM_SRC.ZIP ARM_FORM.ZIP ARM_FSRC.ZIP 2005-SRC.zip 2012-SRC.zip :
	wget http://www.ada-auth.org/arm-files/$@

# delete everything back to mtn checkout
#
# Note that additional 'clean' targets are specified after every
# target that builds something.
clean ::
	rm -f *.stamp *.zip

info-clean :
	rm -f *.info*

.PHONY : force

VPATH = ../source_2005 ../source_2012 ../progs

#Local Variables:
#eval: (delete '("\\.mss\\'" . scribe-mode) auto-mode-alist)
#eval: (ada-parse-prj-file "arm_info.prj")
#eval: (ada-select-prj-file "arm_info.prj")
#End:
# end of file

=== debian/changelog ===
ada-reference-manual (1:2012.3-3) unstable; urgency=medium

  * Debhelper 12.
  * Wrap and sort build dependencies.
  * Standards-Version: 4.4.1.
  * Move VCS to salsa.debian.org.
  * Update and simplify rules script.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 10 Dec 2019 15:43:19 +0100

ada-reference-manual (1:2012.3-2) unstable; urgency=medium

  * Check build with gnat-8: new-gcc-warnings.diff.
  * Build-Depend: gprbuild. Drop no-gnatmake-project-support.diff.
  * Standards-Version: 4.1.4 (no changes).
  * Only include one debian_packaging*.mk, they may become coinstallable.
  * Debhelper 11. Drop explicit rules targets confusing dh.
  * Drop obsolete version restriction for dpkg-dev.
  * Update Vcs-Mtn URL.
  * Rules-Requires-Root: no.
  * Remove overrides for lintian pedantic messages.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 08 May 2018 12:27:33 +0200

ada-reference-manual (1:2012.3-1) unstable; urgency=medium

  * New upstream release. Remove applied patches.
  * PDFLaTeX now produces reproductible documents without faketime.
  * Standards-Version: 4.0.0. Handle DEB_BUILD_OPTIONS=nodoc.
  * Mark both packages as Multi-Arch: foreign.
  * Switch watch file to version 4.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 21 Jun 2017 16:29:32 +0200

ada-reference-manual (1:2012.2-9) unstable; urgency=medium

  * Rebuild with gnat-6 and all hardening options.
  * Drop Depend/Break/Replace restrictions older than oldstable.
  * Standards-Version: 3.9.8 (no changes).

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 27 Apr 2016 17:47:04 +0200

ada-reference-manual (1:2012.2-8) unstable; urgency=medium

  * patches/texinfo-table.diff: avoid TeXinfo @table command. Closes: #817877.
  * patches/no-gnatmake-project-support.diff: use gnatname for file namings,
    instead of a manual patch extended during compilation.
  * patches/clean-tex-aux-files.diff: remove temporary TeX files.
  * Update status and fix DEP-3 syntax in two patches.
  * Standards-Version: 3.9.7 (no changes).

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 02 Apr 2016 17:30:11 +0200

=== debian/control ===
Source: ada-reference-manual
Section: doc
Priority: optional
Maintainer: Ludovic Brenta <lbrenta@debian.org>
Uploaders: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 gnat,
 gprbuild,
 texinfo,
# texi2any
 texlive-fonts-recommended,
# ecrm1095 fonts
 texlive-latex-recommended,
# pdf output module
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/debian/ada-reference-manual
Vcs-Git: https://salsa.debian.org/debian/ada-reference-manual.git
Homepage: http://www.stephe-leake.org/ada/arm.html
# http://www.ada-auth.org/arm.html is the other upstream contact
# but Stephen's page links to them on the front page and this field
# only accepts one value.
Rules-Requires-Root: no

Package: ada-reference-manual-2005
Architecture: all
Multi-Arch: foreign
Suggests: gnat
Depends: ${misc:Depends}
Description: Ada 2005 language standard
 The Ada Reference Manual is the ISO standard describing the
 programming language Ada.
 .
 This package provides the plain and annotated versions of the 2005
 ARM in HTML, PDF, info, and plain text formats.

Package: ada-reference-manual-2012
Architecture: all
Multi-Arch: foreign
Suggests: gnat
Depends: ${misc:Depends}
Description: Ada 2012 language standard
 The Ada Reference Manual is the ISO standard describing the
 programming language Ada.
 .
 This package provides the plain and annotated versions of the 2012
 ARM in HTML, PDF, info, and plain text formats.

=== debian/rules ===
#!/usr/bin/make -f
#
# Makefile for Ada Reference Manual.
# Copyright (c) 2010-2012 Stephen Leake <stephen_leake@stephe-leake.org>
# Copyright (c) 2013-2019 Nicolas Boulenguez <nicolas@debian.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

define NEW_LINE :=


endef

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
  DOCUMENTS := aarm arm
  YEARS     := 2005 2012
  FORMATS   := html info txt pdf
endif

gnat_version := $(shell gnatgcc -dumpversion)
DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_ADAFLAGS_MAINT_APPEND := -gnatoVa -fstack-check
include /usr/share/dpkg/buildflags.mk
include /usr/share/ada/debian_packaging-$(gnat_version).mk

%:
	dh $@ --sourcedirectory=build

# Ignore the upstream build/ directory.
.PHONY: build
build:
	dh $@ --sourcedirectory=build

######################################################################
# Default settings do not produce PDF format.
.PHONY: override_dh_auto_build
override_dh_auto_build:
	dh_auto_build -- \
	  $(foreach v,ADAFLAGS BUILDER_OPTIONS DOCUMENTS FORMATS LDFLAGS YEARS,'$(v)=$($(v))')

######################################################################
.PHONY: override_dh_compress
override_dh_compress:
	dh_compress --all --exclude=.TXT

######################################################################
.PHONY: override_dh_installinfo
override_dh_installinfo:
	$(foreach y,$(YEARS),dh_installinfo --package=ada-reference-manual-$(y)\
          $(foreach d,$(DOCUMENTS),build/$(d)$(y).info)$(NEW_LINE))
	dh_installinfo --remaining-packages

######################################################################
# Debhelper files for doc-base.

TITLE_aarm      := Annotated Ada Reference Manual
TITLE_arm       := Ada Reference Manual
FILEPREFIX_aarm := aa
FILEPREFIX_arm  := rm
ISO_2005        := 2007
ISO_2012        := 201x
ABSTRACT_aarm = The Annotated Ada Reference Manual, ISO/IEC \
 8652:$(ISO_$(y))(E). It contains the entire text of the Ada $(y) \
 standard, plus various annotations. It is intended primarily for \
 compiler writers, validation test writers, and other language \
 lawyers. The annotations include detailed rationale for individual \
 rules and explanations of some of the more arcane interactions among \
 the rules.
ABSTRACT_arm = The Ada Reference Manual, ISO/IEC \
 8652:$(ISO_$(y))(E). It contains the entire text of the Ada $(y) \
 standard.

define foreach_document_year_template

  DOC_BASE_GENERATED += debian/ada-reference-manual-$(y).doc-base.$(d)$(y)
  debian/ada-reference-manual-$(y).doc-base.$(d)$(y): debian/doc_base_template
	sed $$< \
           -e 's@DOCUMENT@$(d)@g' \
           -e 's@YEAR@$(y)@g' \
           -e 's@TITLE@$(TITLE_$(d))@g' \
           -e 's@ABSTRACT@$(ABSTRACT_$(d))@g' \
           -e 's@FILEPREFIX@$(FILEPREFIX_$(d))@g' \
           > $$@

endef
$(foreach d,$(DOCUMENTS),$(foreach y,$(YEARS),\
$(eval $(foreach_document_year_template))))

.PHONY: override_dh_installdocs
override_dh_installdocs: $(DOC_BASE_GENERATED)
	$(foreach y,$(YEARS),dh_installdocs --package=ada-reference-manual-$(y)\
          README.txt \
          $(foreach d,$(DOCUMENTS),build/$(d)$(y).html\
                                   build/$(d)$(y).txt\
                                   build/$(d)$(y).pdf)$(NEW_LINE))
	dh_installdocs --remaining-packages

.PHONY: override_dh_clean
override_dh_clean:
	dh_clean $(DOC_BASE_GENERATED)

######################################################################
# Check that some .txt docs are still duplicates, then symlink.

ifeq (aarm-arm,$(findstring aarm,$(DOCUMENTS))-$(findstring arm,$(DOCUMENTS)))
.PHONY: override_dh_link
override_dh_link:
	$(foreach y,$(YEARS), \
	$(foreach c,Lib TOC, \
	diff -q \
	  debian/ada-reference-manual-$(y)/usr/share/doc/ada-reference-manual-$(y)/aarm$(y).txt/aa-$(c).TXT \
	  debian/ada-reference-manual-$(y)/usr/share/doc/ada-reference-manual-$(y)/arm$(y).txt/rm-$(c).TXT$(NEW_LINE) \
	dh_link --package=ada-reference-manual-$(y) \
	  usr/share/doc/ada-reference-manual-$(y)/aarm$(y).txt/aa-$(c).TXT \
	  usr/share/doc/ada-reference-manual-$(y)/arm$(y).txt/rm-$(c).TXT$(NEW_LINE)))
	dh_link --remaining-packages
endif

## ada-reference-manual 2020.1commit85143dcb

=== build/Makefile ===
--- 
+++ 
@@ -22,7 +22,7 @@
 # Specific targets generate every $document$year.$format combination.
 # Ex: make arm2012.pdf
 AVAILABLE_DOCUMENTS := aarm arm
-AVAILABLE_YEARS     := 2005 2012
+AVAILABLE_YEARS     := 2005 2012 2020
 AVAILABLE_FORMATS   := html info texinfo txt pdf
 
 # 'all' builds all versions except pdf; to build a subset, override these on the command line.
@@ -44,6 +44,9 @@
 # that they take precedence.  The intent is that you may configure the
 # build with a simple variable override.
 
+PYTHON ?= python3
+EMACS_EXE ?= emacs
+
 .PHONY: all clean publish
 
 all: $(foreach d,$(DOCUMENTS),\
@@ -51,6 +54,10 @@
      $(foreach f,$(FORMATS),\
        $(d)$(y).$(f))))
 
+
+create-dir : force
+	for file in *.info; do install-info $$file dir; done
+
 # We have been unable to get rid of all the section ref violations, so we
 # specify --no-validate. Delete that to see the errors.
 TEXI_INFO_OPTS := --no-split --no-number-sections --no-validate
@@ -58,12 +65,14 @@
 
 SOURCE_DIR_2005 := ../source_2005
 SOURCE_DIR_2012 := ../source_2012
+SOURCE_DIR_2020 := ../source_2020
 
 # See progs/command.txt.
 CHANGES      := New-Only
-# See arm_form.exe help for possible values
+# See arm_form.ada comment before Get_Commands for possible values
 VERSION_2005 := 2
 VERSION_2012 := 4
+VERSION_2020 := 5
 
 # Mapping from document acronyms to Randy's file names
 MASTER_arm  := rm.msm
@@ -72,6 +81,7 @@
 # Rough dependency, but Scribe files should not change often.
 SOURCES_2005 := $(wildcard $(SOURCE_DIR_2005)/*.ms[ms])
 SOURCES_2012 := $(wildcard $(SOURCE_DIR_2012)/*.ms[ms])
+SOURCES_2020 := $(wildcard $(SOURCE_DIR_2020)/*.ms[ms])
 define doc_year_build
 
   # Non-unique intermediate paths would create a race condition, so we
@@ -96,19 +106,29 @@
 	mkdir --parents $$@
 	cd $(SOURCE_DIR_$(y)); \
         $(CURDIR)/$$< $(MASTER_$(d)) Text $(CHANGES) $(VERSION_$(y)) $(VERSION_$(y)) $(CURDIR)/$$@/
+	for i in $$@/*; do \
+	  iconv --from-code=iso8859-1 --to-code=utf-8 > $$@/tmp $$$$i && mv $$@/tmp $$$$i; \
+	done
   clean::
 	rm -f -r $(d)$(y).txt
 
+# ../progs/arm-texi-index.el adds texinfo index entries.
+  $(d)$(y).texinfo-index: $(d)$(y).texinfo
+	$(EMACS_EXE) -Q -batch -L ../progs -l arm-texi-index.el --eval '(progn(do-index "$$<")(kill-emacs))'
+	touch $$@
+  clean::
+	rm -f $(d)$(y).texinfo-index
+
 # texi2any is from texinfo 5
-  $(d)$(y).info: $(d)$(y).texinfo
-	texi2any --info $(TEXI_INFO_OPTS) $$< -o $$@
+  $(d)$(y).info: $(d)$(y).texinfo-index
+	texi2any --info $(TEXI_INFO_OPTS) $(d)$(y).texinfo -o $$@
   clean::
 	rm -f $(d)$(y).info
 
   $(d)$(y).pdf: $(d)$(y).texinfo
 	texi2any --pdf $(TEXI_PDF_OPTS) $$< -o $$@
   clean::
-	rm -f $(d)$(y).log $(d)$(y).pdf $(d)$(y).toc
+	rm -f $(d)$(y).aux $(d)$(y).cp $(d)$(y).cps $(d)$(y).log $(d)$(y).pdf $(d)$(y).toc
 
 endef
 $(foreach d,$(AVAILABLE_DOCUMENTS),\
@@ -119,16 +139,16 @@
 	gnatmake -p $(BUILDER_OPTIONS) -P arm_info.gpr $(foreach var,ADAFLAGS LDFLAGS,"-X$(var)=$($(var))")
 clean::
 	rm -f arm_form.exe
-	rm -f -r objects
+	rm -f -r objects __pycache__
 
 trace :
-	addr2line -e arm_form.exe 0x51009e 0x5298ca 0x401fc2 0x405169 0x4013db 0x76cc7c02 0x76f3ab8d 0x76f3ab58
+	addr2line -e arm_form.exe 0x52f218 0x54d4de 0x402123 0x405c6e 0x401393 0x4014f9 0x7ffd98271410 0x7ffd990454f2
 
 # year is latest standard; bump trailing digit for any change.
-ZIP_VERSION := $(lastword $(AVAILABLE_YEARS)).3
+ZIP_VERSION := $(lastword $(AVAILABLE_YEARS)).1
 
 INFO_ARCHIVE := arm_info-$(ZIP_VERSION).tar.gz
-SOURCE_ARCHIVE  := arm_info-$(ZIP_VERSION)-src.tar.gz
+SOURCE_ARCHIVE := arm_info-$(ZIP_VERSION)-src.tar.gz
 publish: $(INFO_ARCHIVE) $(SOURCE_ARCHIVE)
 
 # --no-name eliminates time stamps, which helps make the tarball reproducible
@@ -142,18 +162,16 @@
 clean::
 	rm -f $(INFO_ARCHIVE)
 
-ZIP_EXCLUDES := *~ *.dvi *.gz *.info *.log *.pdf *.ps *.texinfo *.toc \
-  *.stamp *.zip arm_form.exe _MTN .mtn-ignore .dvc-exclude aarm2005.html \
-  aarm2005.txt aarm2012.html aarm2012.txt arm2005.html arm2005.txt arm2012.html \
-  arm2012.txt objects
-$(SOURCE_ARCHIVE):
-	tar cf - -C ../.. $(foreach e,$(ZIP_EXCLUDES),--exclude="$(e)") org.adaic.arm_form | gzip $(GZIP) -c > $@
+$(SOURCE_ARCHIVE): force
+	(cd .. && git archive --prefix=arm_info-$(ZIP_VERSION)-src/ org.adaic.arm_form *) | gzip $(GZIP) -c > $@
+
 clean::
 	rm -f $(SOURCE_ARCHIVE)
 
 update_upstream : source_ada.clean         source_ada.stamp
 update_upstream : source_scribe_2005.clean source_scribe_2005.stamp
 update_upstream : source_scribe_2012.clean source_scribe_2012.stamp
+update_upstream : source_scribe_2020.clean source_scribe_2020.stamp
 
 # download.py does not convert to unix line endings here to minimize
 # the diff with upstream; the Ada compiler can handle DOS line endings
@@ -161,7 +179,7 @@
 # consistency.
 source_ada.stamp :
 	rm -rf ../../org.adaic.arm_form.upstream/progs
-	cd ../../org.adaic.arm_form.upstream; python3 ../org.adaic.arm_form/build/download.py progs
+	cd ../../org.adaic.arm_form.upstream; $(PYTHON) ../org.adaic.arm_form/build/download.py progs
 	touch source_ada.stamp
 
 source_ada.clean :
@@ -176,16 +194,23 @@
 # and arm_form does as well; upstream only runs on Windows, which
 # ignores case in filenames, so the file names in the sources are not
 # consistently cased.
-source_scribe_%.stamp :
+source_scribe_%_downloaded.stamp :
 	rm -rf ../../org.adaic.arm_form.upstream/source_$*
-	cd ../../org.adaic.arm_form.upstream; python3 ../org.adaic.arm_form/build/download.py $*
+	cd ../../org.adaic.arm_form.upstream; $(PYTHON) ../org.adaic.arm_form/build/download.py $*
+
+# download.py often times out, so we need to run it multiple times,
+# then manually mark it done. Then make source_scribe_%.stamp
+mark_%_downloaded :
+	touch source_scribe_$*_downloaded.stamp
+
+source_scribe_%.stamp : source_scribe_%_downloaded.stamp
 	mv ../../org.adaic.arm_form.upstream/source ../../org.adaic.arm_form.upstream/source_$*
 	touch source_scribe_$*.stamp
 
 source_scribe_%.clean :
 	rm -f source_scribe_$*.stamp
 
-# These sources do not match teh correpsonding CVS tag, although they are close.
+# These sources do not match the corresponding CVS tag, although they are close.
 ARM_SRC.ZIP ARM_FORM.ZIP ARM_FSRC.ZIP 2005-SRC.zip 2012-SRC.zip :
 	wget http://www.ada-auth.org/arm-files/$@
 
@@ -201,7 +226,7 @@
 
 .PHONY : force
 
-VPATH = ../source_2005 ../source_2012 ../progs
+VPATH = ../source_2005 ../source_2012 ../source_2020 ../progs
 
 #Local Variables:
 #eval: (delete '("\\.mss\\'" . scribe-mode) auto-mode-alist)

=== debian/changelog ===
ada-reference-manual (1:2020.1commit85143dcb-5) unstable; urgency=medium

  * * Stop pretending that DOCUMENTS is not hardcoded.
  * Standards-Version (no changes).
  * Fix the format of a patch header.
  * Prevent new compiler warnings from breaking Debian builds.
  * Update copyright years.
  * Build-Depend: dh-ada-library for packaging.mk.  Closes: #1067299.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 02 May 2024 16:37:23 +0000

ada-reference-manual (1:2020.1commit85143dcb-4) unstable; urgency=medium

  * ucan: use HTTPS upstream URL
  * Add minimal upstream metadata
  * Simplify debian/rules
  * Let Makefile build texinfo index entries before PDF. Closes: #1013600
  * Set git-buildpackage branch names

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 25 Jun 2022 17:07:26 +0200

ada-reference-manual (1:2020.1commit85143dcb-3) unstable; urgency=medium

  * Use unversioned debian_packaging.mk from gnat (>= 11~).
  * Standards-Version 4.6.1.
  * Update copyright years.
  * Pass build flags via the Make command line (environment is ignored).
  * Remove build flags that repeat upstream defaults.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 22 May 2022 20:40:42 +0000

ada-reference-manual (1:2020.1commit85143dcb-2) unstable; urgency=medium

  * New source-only upload allowing transition to testing.
  * Pass build flags via the environments.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 13 Oct 2020 18:03:05 +0000

ada-reference-manual (1:2020.1commit85143dcb-1) unstable; urgency=medium

  * New upstream release (commit 85143dcb instead of buggy 2020.1 archive).
  * Add a Debian binary package for version 2020 of the manual.
  * Depends: emacs-nox for the new info index generator.
  * Debhelper 13. Standards-Version: 4.5.0.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 13 Jun 2020 18:42:30 +0000

=== debian/control ===
Source: ada-reference-manual
Section: doc
Priority: optional
Maintainer: Ludovic Brenta <lbrenta@debian.org>
Uploaders: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-ada-library (>= 9.1),
 emacs-nox,
 gnat,
 gprbuild,
 texinfo,
# texi2any
 texlive-fonts-recommended,
# ecrm1095 fonts
 texlive-latex-recommended,
# pdf output module
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian/ada-reference-manual
Vcs-Git: https://salsa.debian.org/debian/ada-reference-manual.git
Homepage: http://www.stephe-leake.org/ada/arm.html
# http://www.ada-auth.org/arm.html is the other upstream contact
# but Stephen's page links to them on the front page and this field
# only accepts one value.
Rules-Requires-Root: no

Package: ada-reference-manual-2005
Architecture: all
Multi-Arch: foreign
Suggests: gnat
Depends: ${misc:Depends}
Description: reference documentation for the Ada language (2005 standard)
 The Ada Reference Manual is the ISO standard describing the
 programming language Ada.  The annotated manual provides implementors
 of Ada tools with more background.  Both documents are available in
 HTML, PDF, info, and plain text formats.
 .
 This package installs the 2005 version.

Package: ada-reference-manual-2012
Architecture: all
Multi-Arch: foreign
Suggests: gnat
Depends: ${misc:Depends}
Description: reference documentation for the Ada language (2012 standard)
 The Ada Reference Manual is the ISO standard describing the
 programming language Ada.  The annotated manual provides implementors
 of Ada tools with more background.  Both documents are available in
 HTML, PDF, info, and plain text formats.
 .
 This package installs the 2012 version.

Package: ada-reference-manual-2020
Architecture: all
Multi-Arch: foreign
Suggests: gnat
Depends: ${misc:Depends}
Description: reference documentation for the Ada language (2020 preview)
 The Ada Reference Manual is the ISO standard describing the
 programming language Ada.  The annotated manual provides implementors
 of Ada tools with more background.  Both documents are available in
 HTML, PDF, info, and plain text formats.
 .
 This package installs an unofficial preview of the 2020 version.

# debian/rules must be updated when a new binary package is added

=== debian/rules ===
#!/usr/bin/make -f
#
# Makefile for Ada Reference Manual.
# Copyright (c) 2010-2012 Stephen Leake <stephen_leake@stephe-leake.org>
# Copyright (c) 2013-2024 Nicolas Boulenguez <nicolas@debian.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

YEARS := $(shell \
  sed -n 's/^Package: ada-reference-manual-//p' debian/control)
FORMATS := html info txt pdf

# For now, ADAFLAGS and LDFLAGS must be passed via the command line
# because build/Makefile does not look in the environment.

# Prevent new compiler warnings from breaking Debian builds.
DEB_ADAFLAGS_MAINT_APPEND := -gnatwn

DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/buildflags.mk
include /usr/share/ada/packaging.mk

%:
	dh $@ --sourcedirectory=build

# Ignore the upstream build/ directory.
.PHONY: build
build:
	dh $@ --sourcedirectory=build

######################################################################
# Default settings do not produce PDF format.
.PHONY: override_dh_auto_build
override_dh_auto_build:
	dh_auto_build -- \
	  BUILDER_OPTIONS='$(GNATMAKEFLAGS)' \
	  $(foreach v,ADAFLAGS FORMATS LDFLAGS YEARS,'$(v)=$($(v))')

######################################################################
.PHONY: override_dh_compress
override_dh_compress:
	dh_compress --all --exclude=.TXT

######################################################################
.PHONY: override_dh_installinfo
override_dh_installinfo: $(addprefix installinfo-,$(YEARS))
installinfo-%:
	dh_installinfo --package=ada-reference-manual-$* \
	  build/aarm$*.info build/arm$*.info

######################################################################
# Debhelper files for doc-base.

# This must be updated when the packages change in debian/control.
ISO_2005        := 2007
ISO_2012        := 2012
ISO_2020        := 202x

define foreach_year_template

  installdocs-$(y): debian/ada-reference-manual-$(y).doc-base.aarm$(y) \
                    debian/ada-reference-manual-$(y).doc-base.arm$(y)
  debian/ada-reference-manual-$(y).doc-base.%$(y): debian/doc_base_template_%
	sed 's/@YEAR@/$(y)/g; s/@ISO@/$(ISO_$(y))/g' $$< > $$@

endef
$(foreach y,$(YEARS),$(eval $(foreach_year_template)))

.PHONY: override_dh_installdocs
override_dh_installdocs: $(addprefix installdocs-,$(YEARS))
installdocs-%:
	dh_installdocs --package=ada-reference-manual-$* README.txt \
	  build/aarm$*.html/ build/aarm$*.txt/ build/aarm$*.pdf \
	  build/arm$*.html/  build/arm$*.txt/  build/arm$*.pdf

######################################################################
# Check that some .txt docs are still duplicates, then symlink.

.PHONY: override_dh_link
override_dh_link: $(addprefix link-,$(YEARS))
link-%:
	diff -q \
	  debian/ada-reference-manual-$*/usr/share/doc/ada-reference-manual-$*/aarm$*.txt/aa-Lib.TXT \
	  debian/ada-reference-manual-$*/usr/share/doc/ada-reference-manual-$*/arm$*.txt/rm-Lib.TXT
	diff -q \
	  debian/ada-reference-manual-$*/usr/share/doc/ada-reference-manual-$*/aarm$*.txt/aa-TOC.TXT \
	  debian/ada-reference-manual-$*/usr/share/doc/ada-reference-manual-$*/arm$*.txt/rm-TOC.TXT
	dh_link --package=ada-reference-manual-$* \
	  usr/share/doc/ada-reference-manual-$*/aarm$*.txt/aa-Lib.TXT \
	  usr/share/doc/ada-reference-manual-$*/arm$*.txt/rm-Lib.TXT \
	  usr/share/doc/ada-reference-manual-$*/aarm$*.txt/aa-TOC.TXT \
	  usr/share/doc/ada-reference-manual-$*/arm$*.txt/rm-TOC.TXT

=== debian/watch ===
version=4
https://www.stephe-leake.org/ada/arm.html \
    arm_info-@ANY_VERSION@-src@ARCHIVE_EXT@
